// FileChangeNotify.h: interface for the CFileChangeNotify class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILECHANGENOTIFY_H__FD339221_CFF2_4793_B530_CD3A9AB804C5__INCLUDED_)
#define AFX_FILECHANGENOTIFY_H__FD339221_CFF2_4793_B530_CD3A9AB804C5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>

#include <list>

/*
	CFileChangeNotify - by Chen-hsiu Huang

	class wrapper of WIN32 API
	FindFirstChangeNotification(), FindNextChangeNotification()
	see MSDN if you want to know more detail
*/

using namespace std;

class CFileChangeNotify  
{
	friend DWORD WINAPI watching_thread(LPVOID param);

private:

	list<HANDLE>	m_chHandle;

	// identidy if we're in the watching mode
	bool	m_isWaiting;
	HANDLE m_thread;

public:
	CFileChangeNotify();
	virtual ~CFileChangeNotify();

	void (*m_notifyCallback)(int id);

	int startNotify();
	int addWatch(LPCSTR lpPathName, BOOL bWatchSubtree, DWORD dwNotifyFilter);
	void stopNotify();

};

#endif // !defined(AFX_FILECHANGENOTIFY_H__FD339221_CFF2_4793_B530_CD3A9AB804C5__INCLUDED_)
